<template>
  <TransitionGroup class="todo-list" name="list" tag="ul">
    <TodoItems
      @remove="remove"
      @toggle-todo="toggleTodo"
      v-for="todo in todos"
      :key="todo.id"
      :todo="todo"
    />
  </TransitionGroup>
</template>
<script setup lang="ts">
import { Todo } from "../types/Todo";
import TodoItems from "./TodoItems.vue";

interface Props {
  todos: Todo[];
}
defineProps<Props>();

const remove = (id: number) => {
  emit("remove", id);
};
const toggleTodo = (id: number) => {
  emit("toggleTodo", id);
};

const emit = defineEmits<{
  (e: "remove", id: number): void;
  (e: "toggleTodo", id: number): void;
}>();
</script>

<style scoped>
.list-enter-active,
.list-leave-active {
  transition: all 0.5s ease;
}
.list-enter-from,
.list-leave-to {
  opacity: 0;
  transform: translateY(30px);
}
</style>
